'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = parseTypescript;

var _babylon = require('babylon');

var _tryRequire = require('../utils/try-require');

var _tryRequire2 = _interopRequireDefault(_tryRequire);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var typescript = (0, _tryRequire2.default)('typescript');

function parseTypescript(content, filePath) {
  if (!typescript) {
    return [];
  }

  var compileOptions = {
    module: typescript.ModuleKind.CommonJS,
    target: typescript.ScriptTarget.Latest
  };

  var result = typescript.transpile(content, compileOptions, filePath);

  // TODO avoid parse source file twice, use Typescript native traverser to find out dependencies.
  // Reference: https://github.com/Microsoft/TypeScript/wiki/Using-the-Compiler-API#traversing-the-ast-with-a-little-linter
  return (0, _babylon.parse)(result, {
    sourceType: 'module'
  });
}
module.exports = exports['default'];